/**
 * \file mgui/clipboard.h
 * \brief MGUI::CLIPBOARD definitions
 *
 * \if NODOC
 * $Id: clipboard.h_v 1.1 2010/04/07 17:42:25 mju Exp $
 *
 * $Log: clipboard.h_v $
 * Revision 1.1  2010/04/07 17:42:25  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_MGUI_CLIPBOARD_H
#define	INC_MGUI_CLIPBOARD_H

#ifndef	INC_MI32_STDDEFNS_H
#include <mi32/stddefns.h>
#endif

#ifndef GENERATING_DOXYGEN_OUTPUT
// Forward declarations
class MISTRING;
#endif

namespace MGUI {

//=====================================================================================================================

//! Manager for clipboard.
class CLIPBOARD {
	public:

		//! Get text string from clipboard.
		//! Returned string will be empty if no text in clipboard.
		static const MISTRING& GetText ();

		//! Send a text string to the clipboard
		static void SetText (
			const MISTRING& str
			);

	#ifdef X_NATIVE

		//! (X only) Copy selection from XeText widget to shared clipboard.
		static void XeCopy (Widget xetext);
	
		//! (X only) Cut selection from XeText widget to shared clipboard.
		static void XeCut (Widget xetext);

		//! (X only) Paste over selection in XeText widget from shared clipboard.
		static void XePaste (Widget xetext);
	
	#endif

	private:
	};

//=====================================================================================================================

}	// End namespace MGUI

#endif	// INC_MGUI_CLIPBOARD_H
