/*****************************************************************************
 * \file <mgui/dlglogindboledb.h>
 * \brief MGUI::DLG_LOGIN_DB_OLEDB definitions
 *
 * \if NODOC
 * $Id: dlglogindboledb.h_v 1.4 2011/06/21 19:44:08 mju Exp $
 *
 * $Log: dlglogindboledb.h_v $
 * Revision 1.4  2011/06/21 19:44:08  mju
 * Rename.
 *
 * Revision 1.3  2006/04/14 19:26:35  dwilliss
 * use generic rdbmslogin base class
 *
 * Revision 1.1  2006/01/26 18:41:25  dwilliss
 * Initial revision
 * \endif
 ****************************************************************************/

#ifndef INC_MGUI_DLGLOGINDBOLEDB_H
#define INC_MGUI_DLGLOGINDBOLEDB_H

#ifndef INC_MGUI_DLGLOGINDB_H
#include <mgui/dlglogindb.h>
#endif

namespace MGUI {

//=====================================================================================================================

//! Dialog to login to OLEDB server.
class DLG_LOGIN_DB_OLEDB : public MGUI::DLG_LOGIN_DB {
	public:

		DLG_LOGIN_DB_OLEDB ();

		virtual ~DLG_LOGIN_DB_OLEDB ();

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		
		virtual bool v_CanUseWindowsLogin () const;

      virtual void v_GetConnectionString (
         MISTRING& ConnectionString,
         bool bForGettingDatabaseList,
         const MISTRING& Host,
         const MISTRING& User,
         const MISTRING& Password,
         const MISTRING& Database,
         const MISTRING& Schema,
         INT32 port
         );  

      virtual const char* v_GetINIGroup () const;

		#endif
	};

//=====================================================================================================================

}	// End namespace MGUI

#endif
