/**
 * \file mi32/textbase.h
 * \brief Define TEXTBASEORIGIN enum
 *
 * \if NODOC
 * $Id: textbase.h_v 1.3 2011/09/06 21:34:16 mju Exp $
 *
 * $Log: textbase.h_v $
 * Revision 1.3  2011/09/06 21:34:16  mju
 * Rename macro.
 *
 * Revision 1.2  2003/09/15 13:49:56  fileserver!dwilliss
 * Doxygen
 *
 * Revision 1.1  2000/05/11 13:26:07  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_MI32_TEXTBASE_H
#define	INC_MI32_TEXTBASE_H

//! Text basepoint origin flags.
enum TEXTBASEORIGIN {
	TEXTBASEORIGIN_FirstLine =					0x00,	//!< Base of first line
	TEXTBASEORIGIN_Left =						0x01,	//!< Left edge of text
	TEXTBASEORIGIN_CenterHorz =				0x02,	//!< Center text horizontally
	TEXTBASEORIGIN_Right =						0x04,	//!< Right edge of text
	TEXTBASEORIGIN_CenterHorzFirstTag =		0x08,	//!< Center horizontally using first tag in block
	TEXTBASEORIGIN_Top =							0x10,	//!< Top of text
	TEXTBASEORIGIN_CenterVert =				0x20,	//!< Center vertically
	TEXTBASEORIGIN_Bottom =						0x40,	//!< Bottom of text
	TEXTBASEORIGIN_CenterVertFirstLine =	0x80	//!< Center vertically using first line only
	};
#ifndef GENERATING_DOXYGEN_OUTPUT
DEFINE_ENUM_OP_BITWISE(TEXTBASEORIGIN)
#endif

#endif	// INC_MI32_TEXTBASE_H
