/**
 * \file rvc/displyt.h 
 * \brief interface for the RVC::DISPLAYOUT class.
 *
 * \if NODOC
 * $Id: displyt.h_v 1.8 2006/09/08 19:28:12 scowan Exp $
 *
 * $Log: displyt.h_v $
 * Revision 1.8  2006/09/08 19:28:12  scowan
 * Change enum from serialize to its own enum.
 *
 * Revision 1.7  2005/06/30 21:01:56  scowan
 * Added makeparms.
 *
 * Revision 1.6  2003/10/07 17:34:20  scowan
 * Object virtual method changes.
 *
 * Revision 1.5  2003/09/30 16:52:06  dwilliss
 * Doxygen
 *
 * Revision 1.4  2003/09/25 21:20:04  dwilliss
 * Fixed doxygen comment
 *
 * Revision 1.3  2003/09/15 13:49:45  fileserver!dwilliss
 * Doxygen
 *
 * Revision 1.2  2001/06/15 14:24:59  scowan
 * Added to RVC namespace.
 *
 * Revision 1.1  2000/11/29 17:11:47  scowan
 * Initial revision
 *
 * \endif
**/

//!
//!	\class RVC::DISPLAYOUT rvc/displyt.h
//!	\brief Manages RVC::OBJTYPE_Display_Layout objects.
//!
//!	The RVC::DISPLAYOUT class manages RVC::OBJTYPE_Display_Layout objects.
//!
//!	RVC Object Types that this class supports: RVC::OBJTYPE_Display_Layout
//!
//!	Default RVC Object Type for this class: RVC::OBJTYPE_Display_Layout
//!
//!	Valid parents for this class:
//!		- RVC::OBJTYPE_File
//!		- RVC::OBJTYPE_Folder

#ifndef INC_RVC_DISPLYT_H
#define INC_RVC_DISPLYT_H

#ifndef INC_RVC_SERIALZE_H
	#include <rvc/serialze.h>
#endif

namespace RVC {

class DISPLAYOUT : public RVC::SERIALIZE {
	public:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		class MAKEPARMS;
		#endif

		//! Default constructor
		DISPLAYOUT (
			);

		//! Copy constructor
		DISPLAYOUT (
			const RVC::DISPLAYOUT& obj
			);

		//! Destructor
		virtual ~DISPLAYOUT (
			);

		//! Assignment
		RVC::DISPLAYOUT& operator= (
			const RVC::DISPLAYOUT& rhs
			);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		//! Implementation of RVC::OBJECT virtual methods
		virtual OBJTYPE v_GetDftObjectType ();
		#endif // GENERATING_DOXYGEN_OUTPUT
	};


class DISPLAYOUT::MAKEPARMS : public SERIALIZE::MAKEPARMS {
	public:
		MAKEPARMS (
			UINT16 Version = 1				 			//!< Version number to assign to new object
			) : SERIALIZE::MAKEPARMS(OBJTYPE_Display_Layout, Version, RVC::OBJTYPE_All, DISPPARMUSAGE_Display)
			{}
	};			

}		//! End of RVC namespace

#endif 	//!< INC_RVC_DISPLYT_H
