/******************************************************************************
 *
 * \file sml/flag.h
 * \brief SML FLAG
 *
 * \if NODOC
 * $Log: flag.h_v $
 * Revision 1.2  2007/05/08 15:45:48  dwilliss
 * SML namespace
 *
 * Revision 1.1  2007/05/04 22:39:36  dwilliss
 * Initial revision
 *
 * \endif
*/
/*****************************************************************************/

#ifndef INC_SML_FLAG_H
#define INC_SML_FLAG_H

#ifndef INC_MI32_STDDEFNS_H
#include <mi32/stddefns.h>
#endif

namespace SML {
/***************************************************************************/
/**
 * Parameter flag value definition
 *
 * These are meant to be statically defined and normally use (char*) in the ASCII
 * range.  Since there are a few cases where we need Unicode, interpret the name
 * and desc as UTF8.  This will cause no change for statically defined strings,
 * as they're all chars < 128.  In the few places where we need to make one
 *	Unicode, convert it to UTF8 and store that.
 */
class FLAG {
	public:
		char *name;
		UINT32 value;
		char *desc;
	};

} // end of SML namespace

typedef SML::FLAG SMLFLAG;

#endif		//  INC_SML_FLAG_H


